from .data import DataSeq
import random


def Qsort(ds, Left, Right):
    Cutoff = 10
    if Cutoff <= Right-Left:
##        因为这里在小于10个数的时候就采用了插入排序，因此不必判断只有一个数据或者没有数据的情况
        # start=end ,证明要处理的数据只有一个
        # start>end ,证明右边没有数据
##        if start >= end: # 只有一个数据或者没有数据的情况
##            return
        mid_index = random.randint(0, Right - Left) + Left # 根据参数的个数生成随机数Right - Left
        Pivot = ds.data[mid_index] # 找到基准值
##        Pivot = ds.data[Left]
        low = Left # 分区后，虽然最左面位置留给基准值置换使用，但是left还需要从第0位开始，因为要置换和保留最小的元素，不同于双向扫描。
        high = Right

        
##        # 将随机出来的数放到第0个位置就可以使用传统的快排代码了
        temp = ds.data[Left]
        ds.SetVal(Left, Pivot)
        ds.SetVal(mid_index, temp)
                
        while low < high:
            while low < high and ds.data[high] >= Pivot: # 从右侧开始找到比基准值小的那个值的索引号
                high -= 1
            ds.SetVal(low, ds.data[high]) # 非常精细，所以用不到Swap，只用到了SetVal
            
            while low < high and ds.data[low] < Pivot: # 从左侧开始找到比基准值大的那个值的索引号
                low += 1
            ds.SetVal(high, ds.data[low]) # 非常精细，所以用不到Swap，只用到了SetVal
        ds.SetVal(low, Pivot)
        
        Qsort(ds, Left, low-1)
        Qsort(ds, low+1, Right)

    else:
        # 元素太少，用插入排序
        for p in range(Left,Right+1):
            tmp = ds.data[p]
            i=p
            while i>=1 and ds.data[i-1]>tmp:
                ds.SetVal(i, ds.data[i-1])
                i-=1
            ds.SetVal(i, tmp)

def RandomQuickSort(ds):
    assert isinstance(ds, DataSeq), "Type Error"

    Length = ds.length
    Qsort(ds, 0, Length-1)

if __name__ == "__main__":
    ds=DataSeq(64)
    print(ds)
    ds.Visualize()
    ds.StartTimer()
    ds.SetTimeInterval(100)
    RandomQuickSort(ds)
    ds.StopTimer()
    print(ds)
    ds.Visualize()
